DEFINT A-Z

TYPE PalValue
    Red AS STRING * 1
    Green AS STRING * 1
    Blue AS STRING * 1
END TYPE


DECLARE SUB ClearBit (Value%, Bit%)
DECLARE SUB SetBit (Value%, Bit%)
DECLARE SUB testpattern1 ()
DECLARE FUNCTION Int2Bin$ (n%)
DECLARE SUB TurnOffScreen ()
DECLARE SUB TurnOnScreen ()
DECLARE SUB SetSequencerBit (Value%)
DECLARE SUB ClearSequencerBit (Value%)
DECLARE SUB TurnOffScreenf ()
DECLARE SUB TurnOnScreenf ()
DECLARE SUB UnknownCycleTest1f ()

DECLARE SUB GetSequencerIndexValue (Index%, Value%)
DECLARE SUB GetSequencerIndex (Value%)
DECLARE SUB SetSequencerIndex (Value%)
DECLARE SUB SetSequencerIndexValue (Index%, Value%)
DIM SHARED Storageforanalysisafterthefact(0 TO 7)
DIM SHARED ClearBitArray(0 TO 7) AS INTEGER
DIM SHARED SetBitArray(0 TO 7) AS INTEGER
   
    FOR i = 0 TO 7
    READ ClearBitArray(i)
    NEXT
    FOR i = 0 TO 7
       READ SetBitArray(i)
    NEXT
    SCREEN 13
    testpattern1
    DO: LOOP UNTIL INKEY$ <> ""
    TurnOffScreen
    LINE (20, 20)-(40, 40), 15, BF

    DO: LOOP UNTIL INKEY$ <> ""
    TurnOnScreen
    DO: LOOP UNTIL INKEY$ <> ""
    PRINT "doing loop"
    UnknownCycleTest1f
    'END
    Value = &HFF
    FOR i = 0 TO 7
      SetSequencerIndexValue i, Value%
      GetSequencerIndexValue i, Storageforanalysisafterthefact(i)
       
      PRINT Value%
    NEXT i
    'OUT &H3C4, 0
    'Value% = INP(&H3C5)
    'OUT &H3C5, 0
    'END
'Recovery
    SCREEN 0
    WIDTH 80
    SCREEN 13
    FOR i = 0 TO 7
      PRINT Storageforanalysisafterthefact(i), Int2Bin$(Storageforanalysisafterthefact(i))
    NEXT i
ClearBitArrayData:
DATA &HFFFE,&HFFFD,&HFFFB,&HFFF7,&HFFEF,&HFFDF,&HFFBF,&HFFF7
SetBitArrayData:
DATA 1,2,4,8,16,32,64,128

SUB ClearBit (Value%, Bit%)
    Value% = Value% AND ClearBitArray(Bit%)
END SUB

SUB ClearSequencerBit (Value)
    Temp% = INP(&H3C5)
    CALL ClearBit(Temp%, Value%)
    OUT &H3C5, Temp%
END SUB

SUB GETPAL (Entry%, Value AS PalValue)
   OUT &H3C7, Entry%                   'tell controller to get ready
   Temp% = INP(&H3C9)              'get red component
   Value.Red = CHR$(Temp%)
   Temp% = INP(&H3C9)
   Value.Green = CHR$(Temp%)       'get green component
   Temp% = INP(&H3C9)     'get blue component
   Value.Blue = CHR$(Temp%)
END SUB

SUB GetSequencerIndex (Value%)
    Value% = INP(&H3C4)
END SUB

SUB GetSequencerIndexValue (Index%, Value%)
    OUT &H3C4, Index%
    Value% = INP(&H3C5)
END SUB

SUB GetSequencerResetByte (Value%)
    OUT &H3C4, 0
    Value% = INP(&H3C5)
END SUB

FUNCTION Int2Bin$ (n%)
    Temp1$ = HEX$(n%)
    Temp$ = ""
    FOR i = 1 TO LEN(Temp1$)
      SELECT CASE MID$(Temp1$, i, 1)
      CASE "0": Temp$ = Temp$ + "0000"
      CASE "1": Temp$ = Temp$ + "0001"
      CASE "2": Temp$ = Temp$ + "0010"
      CASE "3": Temp$ = Temp$ + "0011"
      CASE "4": Temp$ = Temp$ + "0100"
      CASE "5": Temp$ = Temp$ + "0101"
      CASE "6": Temp$ = Temp$ + "0110"
      CASE "7": Temp$ = Temp$ + "0111"
      CASE "8": Temp$ = Temp$ + "1000"
      CASE "9": Temp$ = Temp$ + "1001"
      CASE "A": Temp$ = Temp$ + "1010"
      CASE "B": Temp$ = Temp$ + "1011"
      CASE "C": Temp$ = Temp$ + "1100"
      CASE "D": Temp$ = Temp$ + "1101"
      CASE "E": Temp$ = Temp$ + "1110"
      CASE "F": Temp$ = Temp$ + "1111"
      CASE ELSE
      END SELECT
    NEXT
    Int2Bin$ = Temp$
END FUNCTION

SUB SequencerAllIndexTest
    
    FOR i = 0 TO 7
      SetSequencerIndexValue i, Value%
      GetSequencerIndexValue i, Storageforanalysisafterthefact(i)
       
      PRINT Value%
    NEXT i
END SUB

SUB SequencerIndexExistanceTest
    FOR i = 0 TO 255
    SetSequencerIndex i
    GetSequencerIndex Value%
    PRINT Value%;
    NEXT i
END SUB

SUB SetBit (Value%, Bit%)
    Value% = Value% OR SetBitArray(Bit%)
END SUB

SUB SetPal (Entry%, Value AS PalValue)
   OUT &H3C8, Entry%                            'tell controller to get ready
  
   OUT &H3C9, ASC(Value.Red)                      'send red component
   OUT &H3C9, ASC(Value.Green)                    'send green component
   OUT &H3C9, ASC(Value.Blue)                     'send blue component
END SUB

SUB SetSequencerBit (Value%)
    Temp% = INP(&H3C5)
    CALL SetBit(Temp%, Value%)
    OUT &H3C5, Temp%
END SUB

SUB SetSequencerIndex (Value%)
    OUT &H3C4, Value%
END SUB

SUB SetSequencerIndexValue (Index%, Value%)
    OUT &H3C4, Index%
    OUT &H3C5, Value%
END SUB

SUB testpattern1
LINE (0, 0)-(319, 199), 15, B
LINE (0, 0)-(319, 199), 15
LINE (0, 199)-(319, 0), 15
END SUB

SUB TurnOffScreen
    SetSequencerIndex 1
    SetSequencerBit 5

END SUB

SUB TurnOffScreenf
    OUT &H3C4, 1
    Temp% = INP(&H3C5)
    CALL SetBit(Temp%, 5)
    OUT &H3C5, Temp%
END SUB

SUB TurnOnScreen
    SetSequencerIndex 1
    ClearSequencerBit 5
END SUB

SUB TurnOnScreenf
    OUT &H3C4, 1
    Temp% = INP(&H3C5)
    CALL ClearBit(Temp%, 5)
    OUT &H3C5, Temp%
END SUB

SUB UnknownCycletest1
    DO:
    TurnOffScreen
    TurnOnScreen
    LOOP UNTIL INKEY$ <> ""

END SUB

SUB UnknownCycleTest1f
    DO:
    TurnOffScreenf
    TurnOnScreenf
    LOOP UNTIL INKEY$ <> ""
END SUB

